/*
 * CalculatedReading.java
 */

package sensor.raeSystems.multiRAEPlus;

public class CalculatedReading {
    
    /** Creates a new instance of CalculatedReading */
    public CalculatedReading(String sensorName, double peak, double low,
            double stel, double twa) {
        this.toxic = true;
        this.sensorName = sensorName;
        this.peakValue = peak;
        this.lowValue = low;
        this.STEL = stel;
        this.TWA = twa;
    }
    
    /** Creates a new instance of CalculatedReading */
    public CalculatedReading(String sensorName, double peak, double low) {
        this.toxic = false;
        this.sensorName = sensorName;
        this.peakValue = peak;
        this.lowValue = low;
    }
    
    /**
     * Holds value of property sensorName.
     */
    private String sensorName;
    
    /**
     * Getter for property sensorName.
     * @return Value of property sensorName.
     */
    public String getSensorName() {
        return this.sensorName;
    }
    
    
    /**
     * Holds value of property lowValue.
     */
    protected double lowValue;
    
    /**
     * Getter for property lowValue.
     * @return Value of property lowValue.
     */
    public double getLowValue() {
        return this.lowValue;
    }
    
    /**
     * Holds value of property peakValue.
     */
    protected double peakValue;
    
    /**
     * Getter for property peakValue.
     * @return Value of property peakValue.
     */
    public double getPeakValue() {
        return this.peakValue;
    }
    
    /**
     * Holds value of property STEL.
     */
    protected double STEL;
    
    /**
     * Getter for property STEL.
     * @return Value of property STEL.
     */
    public double getSTEL() {
        if (!toxic) {
            throw new IllegalStateException("STEL not available because "
                    + getSensorName() + " is not toxic.");
        }
        return this.STEL;
    }
    
    /**
     * Holds value of property TWA.
     */
    protected double TWA;
    
    /**
     * Getter for property TWA.
     * @return Value of property TWA.
     */
    public double getTWA() {
        if (!toxic) {
            throw new IllegalStateException("TWA not available because "
                    + getSensorName() + " is not toxic.");
        }
        return this.TWA;
    }
    
    /**
     * Holds value of property toxic.
     */
    protected boolean toxic;
    
    /**
     * Getter for property toxic.
     * @return Value of property toxic.
     */
    public boolean isToxic() {
        return this.toxic;
    }
    
    public String toString() {
        if (toxic) {
            return sensorName + "\tPeak: " + peakValue + "\tLow: " + lowValue 
                    + "\tSTEL: " + STEL + "\tTWA: " + TWA + "\n";
        } else {
            return sensorName + "\tPeak: " + peakValue + "\tLow: " + lowValue 
                    + "\n";
        }
    }
    
}
